%{
    #include <stdio.h>
    extern void yyerror(const char*);
    extern int yylex(void);
%}

%token BYT FRAS KLART KOLON SEMIKOLON ORD
%define parse.error verbose
%start inmatning

%%

inmatning : kommandon klartkommando ;

klartkommando : KLART SEMIKOLON ;

kommandon : kommando kommandon | %empty ;

kommando : BYT ORD KOLON flera_ord SEMIKOLON | BYT FRAS flera_ord KOLON flera_ord SEMIKOLON ;

flera_ord : flera_ord ORD | ORD ;

%%

int main() {
    printf("Skriv in en inmatning. Avsluta med CTRL-D.\n");
    yyparse();
    printf("Done.\n");
    return 0;
}

void yyerror(const char *s) {
    printf("Goodbye. You have failed. This is how you failed: %s.\n", s);
}

int yywrap(void) {
    return 1;
}
